#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.do { global EOT = 65536; readonly EOT; }

openflow(id param dir name)
{
	global dir_$id = $dir doread_$id = true ungetc_$id;
	defautoseq enc_$id base64enc;
	defautoseq dec_$id base64enc:Decode;
	defstream stream_$id $name basic $dir
}

closeflow(id)
{
	if var(dir_$id)
		::ioctl($id flush)
	endif
	remove GLOBALS val_$id
	remove GLOBALS cnt_$id
	remove GLOBALS ll_$id
	rmautoseq dec_$id
	rmautoseq enc_$id
	rmstream stream_$id
}

getc(id)
{
	def ch out;
	if var(ungetc_$id) set out = var(ungetc_$id) clear ungetc_$id return($out) endif
	if isfinal(dec_$id) return endif
	while;
		if var(doread_$id)
			set ch = ascii(readfrom(stream_$id))
			clear doread_$id
		endif
		set out = ctranslate(dec_$id $ch)
		clear ch;
		set doread_$id = isprefix($out +)
	loop(not(substr($out 1)));
	return(substr($out 1))
}

ungetc(id ch)
{
	if var(ungetc_$id) return(error) endif
	set ungetc_$id = $ch
}

putc(id ch)
{
	writeto stream_$id cond(eq(int 0 $ch) translatez(enc_$id '') translate(enc_$id char($ch)));
}

puts(id str)
{
	writeto stream_$id translate(enc_$id $str);
}

# Positioning functions are just thunks
# Probably needs a finer state saving?
getpos(id)
{
	return(getpos(stream_$id))
}

setpos(id pos)
{
	::ioctl($id flush)
	setpos stream_$id $pos
}

rewind(id)
{
	::ioctl($id flush)
	rewind stream_$id
}

ioctl(id ctl)
{
	if eq($ctl flush)
		if var(dir_$id)
			def out = ctranslate(enc_$id $EOT);
			while;
				if substr($out 1)
					writeto stream_$id char(substr($out 1))
				endif
				if isprefix($out +) break endif
				set out = ctranslate(enc_$id '')
			loop;
		endif
		reset enc_$id
		reset dec_$id
		clear ungetc_$id
	else
		return(ioctl(stream_$id flowctl=$ctl))
	endif
}

# The code will be rewritten using `flowio' module as soon as the latter will appear