#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

streamopen(id arg writable)
{
	pool div_$id
	using div_$id
	array tags_$id;
	shared chars div_pos = 0;
}

streamclose(id)
{
	using div_$id
	def i;
	foreach i tags_$id
		release storage get(tags_$id $i)
	loop
	release storage tags_$id;
	rmpool div_$id
}

read(id)
{
	using div_$id
	cleartag
	if eq(int $div_pos length($chars)) return endif
	if check(tags_$id $div_pos)
		def l = get(tags_$id $div_pos);
		def i;
		foreach i $l
			settag $i get($l $i)
		loop
	else
		settagchar ascii(substr($chars $div_pos 1))
	endif
	incr div_pos 1
}

writestr(id str)
{
	using div_$id
	def i;
	set chars = replace($chars $div_pos length($str) $str)
	foreach i local(sequence(\[$div_pos\-add($div_pos sub(length($str) 1))\]))
		if check(tags_$id $i)
			release storage get(tags_$id $i)
			remove tags_$id $i
		endif 
	loop
	incr div_pos length($str)
}

writetag(id)
{
	if not($[]) writestr($id $[value]) endif
	using div_$id
	set chars = replace($chars $div_pos 1 \e)
	def l tags = $[*] name val;
	if check(tags_$id $div_pos)
		release storage get(tags_$id $div_pos)
		set l = list()
		put tags_$id $div_pos $l
	else
		set l = list()
		insert tags_$id $div_pos $l
	endif
	while $tags
		set tags = split($tags \t \n name val);
		insert $l $name $val
	loop
	insert $l '' $[]
	incr div_pos 1
}

rewind(id)
{
	using div_$id
	set div_pos =  0
}

setpos(id pos)
{
	using div_$id
	if or(less(int $pos 0) greater(int $pos count(div_$id)))
		error "diversion $id: invalid offset $pos"
	endif
	set div_pos = $pos
}

getpos(id)
{
	using div_$id
	return($div_pos)
}

ioctl(id ctl)
{
	using div_$id
	switch $ctl
		case 'insert'
			set chars = replace($chars $div_pos 0 ' ')
			foreach i local(sequence(\[length($chars)\-add(1 $div_pos)\]))
				if check(tags_$id sub($i 1))
					if check(tags_$id $i)
						put tags_$id $i get(tags_$id sub($i 1))				
					else
						insert tags_$id $i get(tags_$id sub($i 1))
					endif
				elsif check(tags_$id $i)
					remove tags_$id $i						
				endif
			loop
			breaksw
		case 'remove'
			set chars = replace($chars $div_pos 1 '')
			if check(tags_$id $div_pos)
				release storage get(tags_$id $div_pos)
				remove tags_$id $div_pos
			endif
			breaksw
		case 'length'
			return(length($chars))
		case '*'
			return(not-implemented)
	endsw
}

put-or-insert(array item val)
{
	if check($array $item)
		release storage get($array $item)
		put $array $item $val
	else
		insert $array $item $val
	endif
}
