#
# 	Copyright (C) 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.automaton docstrip_html
.define true -1;
.define Protect 1;
.define Pre 2;
.define pre 200;
.define tabbing 201;
.define NON_JOINER 0x7f;

.start Protect;

.define after_dash 100;
.define after_dash2 101;
.define after_paren 102;
.define after_exclam 103;
.define after_less 104;
.define after_tilde 105;
.define after_equal 107;
.define after_parenc 108;
.define after_greater 109;
.define after_plus 110;
.define after_lessd 111;
.define after_lessd2 112;
.define after_lesse 113;
.define after_lesse2 114;
.define after_equal2 115;
Protect; $$ = '\"'; true; Protect; { "&quot;" }{}
Protect; $$ = '&'; true; Protect; { "&amp;" }{}
Protect; $$ = '-'; true; after_dash; {}{}
Protect; $$ = '~'; true; after_tilde; {}{}
Protect; $$ = '<'; true; after_less; {}{}
Protect; $$ = '>'; true; after_greater; {}{}
Protect; $$ = '('; true; after_paren; {}{}
Protect; $$ = '='; true; after_equal; {}{}
Protect; $$ = '+'; true; after_plus; {}{}
Protect; $$ = NON_JOINER; true; Protect; {}{}
Protect; true; true; Protect; { $$; }{}
after_dash; $$ = '-'; true; after_dash2; {}{}
after_dash; $$ = '>'; true; Protect; { "&rarr;" }{}
after_dash; ^true; true; Protect; { '-'; }{}
after_dash2; $$ = '-'; true; Protect; { "&mdash;" }{}
after_dash2; $$ = '>'; true; Protect; { "&rarr;" }{}
after_dash2; ^true; true; Protect; { "&ndash;" }{}
after_tilde; $$ = '~'; true; Protect; { '~'; }{}
after_tilde; ^true; true; Protect; { "&nbsp;" }{}
after_paren; $$ = 'c' || $$ = 'C'; true; after_parenc; {}{ $$; }
after_paren; ^true; true; Protect; { '('; }{}
after_parenc; $$ = ')'; true; Protect; { "&copy;" }{}
after_parenc; ^true; true; Protect; { '('; $1; }{}
after_exclam; $$ = '='; true; Protect; { "&ne;" }{}
after_exclam; ^true; true; Protect; {}{}
after_less; $$ = '-'; true; after_lessd; {}{}
after_less; $$ = '='; true; after_lesse; {}{}
after_less; ^true; true; Protect; { "&lt;" }{}
after_lessd; $$ = '-'; true; after_lessd2; {}{}
after_lessd; $$ = '>'; true; Protect; { "&harr;" }{}
after_lessd; ^true; true; Protect; { "&larr;" }{}
after_lessd2; $$ = '>'; true; Protect; { "&harr;" }{}
after_lessd2; ^true; true; Protect; { "&larr;" }{}
after_lesse; $$ = '='; true; after_lesse2; {}{}
after_lesse; $$ = '>'; true; Protect; { "&hArr;" }{}
after_lesse; ^true; true; Protect; { "&le;" }{}
after_lesse2; $$ = '>'; true; Protect; { "&hArr;" }{}
after_lesse2; ^true; true; Protect; { "&lArr;" }{}
after_equal; $$ = '>'; true; Protect; { "&ge;" }{}
after_equal; $$ = '='; true; after_equal2; {}{}
after_equal; ^true; true; Protect; { '='; }{}
after_equal2; $$ = '>'; true; Protect; { "&rArr;" }{}
after_equal2; ^true; true; Protect; { "==" }{}
after_plus; $$ = '-'; true; Protect; { "&plusmn;" }{}
after_plus; ^true; true; Protect; { '+'; }{}
after_greater; $$ = '='; true; Protect; { "&ge;" }{}
after_greater; ^true; true; Protect; { "&gt;" }{}

Pre; true; true; pre; {}{ $$:2, 0; }
pre; $$ = '\t'; true; tabbing; {} { $1 + $2 - ($1 % $2); $2 - ($1 % $2); } 
pre; true; true; pre; { $$; } { $1 + 1; }
tabbing; ^true; $1 = 0; pre; {}{}
tabbing; ^true; true; tabbing; { ' '; }{ $1 - 1; }

.define DetectHref 5;
.define Href_URL 500;
.define Href_Mail 501;
.define Href_Man 502;
.define check_man 505;
.define check_web 506;
.final Href_URL;
.final Href_Mail;
.final Href_Man;
DetectHref; $$ = 0; true; Href_URL; {}{}
DetectHref; $$ = ':'; true; Href_URL; {}{}
DetectHref; $$ = '@'; true; Href_Mail; {}{} 
DetectHref; $$ = '('; true; check_man; {}{}
DetectHref; true; true; DetectHref; {}{}
check_man; $$@['1'-'9'] >= 0; true; Href_Man; {}{}
check_man; true; true; Href_URL; {}{}
DetectHref; true; true; DetectHref; {}{}
Href_URL; true; true; Href_URL; {}{}
Href_Mail; true; true; Href_Mail; {}{}
Href_Man; true; true; Href_Man; {}{}

.define Man2URL 6;
Man2URL; $$ = ' '; true; Man2URL; {}{}
Man2URL; $$ = '('; true; Man2URL; { '.'; }{}
Man2URL; $$ = ')'; true; Man2URL; { ".html" }{}
Man2URL; true; true; Man2URL; { $$; }{}
.end

writetagn(...;)
{
	writetag passargs(1);
	write \n
}

warning(text)
{
	if not($quiet)
		echo "docstrip_html: $text"
	endif
}

streamopen(id arg writable)
{
	pool dsh_$id
	using dsh_$id
	shared linewidth = 80 in-body title = $arg pre tabsize = 8 indenting in-list; 
	shared doc-lang doc-enc author;
	shared buffer;
	shared divert cur-out = out:$id this-file;
	if $arg
		if and(not(issuffix($arg .html)) not(issuffix($arg .htm)))
			set arg = $(arg).html
		endif
	endif
	set this-file = $arg
	defstream out:$id file://$arg html true;
	outstream out:$id
	defstream divert:$id inline://dsh_$id/divert html true
	writetagn ! rest 
'DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" "http://www.w3.org/TR/html4/loose.dtd"';
	writetagn HTML;
	writetagn HEAD;
	writetagn META NAME Generator CONTENT 'DocStrip 2 HTML driver');
	once({
		global quiet;
		global hrefdump;
		defautoseq protect docstrip_html:Protect;
		defautoseq pre docstrip_html:Pre|html;
		defautoseq chkhref docstrip_html:DetectHref;
		defautoseq man2url docstrip_html:Man2URL;
		defautoseq html html;
		table anchors ''
	})
	def iter;
	foreach iter anchors
		if not(get(anchors $iter))
			warning("there are forward references outside a file");
			break
		endif
	loop
}

atexit
{
	if $hrefdump
		defstream hrefs $hrefdump basic true;
		def iter;
		foreach iter anchors
			if get(anchors $iter)
				writeto hrefs $iter\tget(anchors $iter)\n
			endif
		loop
		rmstream hrefs
	endif
}

streamclose(id)
{
	using dsh_$id
	outstream $cur-out
	flush-buffern()
	writetagn /BODY;
	writetagn /HTML;
	outstream ''
	release stream out:$id
	release stream divert:$id
	rmpool dsh_$id
}

read(id)
{
	error "cannot read from here"
}

flush-buffer()
{
	shared just-nl;
	if $buffer clear just-nl endif
	ioctl outstream() raw
	write $buffer
	ioctl outstream() cooked
	clear buffer
}

flush-buffern()
{
	flush-buffer()
	if not($just-nl)
		write \n
	endif
	set just-nl = true
}

start-body()
{
	set buffer = $title
	writetagn TITLE;
	flush-buffer()
	writetagn /TITLE;
	if $author
		writetagn META NAME Author CONTENT $author;
	endif
	if $doc-lang
		writetagn META HTTP-EQUIV Content-Language CONTENT $doc-lang;
	endif
	writetagn META HTTP-EQUIV Content-Type CONTENT 'text/html'cond($doc-enc '; 'charset=$doc-enc);
	writetagn /HEAD;
	writetagn BODY;
	set in-body = true
}

writestr(id str)
{
	if not($str) return endif
	using dsh_$id
	outstream $cur-out
	if not($in-body) start-body() endif
	if $pre
		def ch;
		while $str
			set ch = substr($str 0 1)
			set str = substr($str 1)
			if eq($ch \n)
				ctranslate(reset(pre) $tabsize)
				set buffer = translate(pre $buffer)
				flush-buffern()
			else
				set buffer = $buffer$ch
			endif
		loop
	else
		set buffer = $(buffer)translate(reset(protect) $str)
		if ge(int length($buffer) $linewidth) flush-buffern() endif
	endif
}

tag "H[123]"
{
	flush-buffern()
	if $indenting 
		writetag /TD;
		writetagn /TR;
		writetagn /TABLE;
		clear indenting
	endif
	writetag;
}

tag "/H[123]"
{
	flush-buffer()
	writetag;
	write \n
}

tag "ANCHOR"
{
	flush-buffer()
	if check(anchors tag(NAME))
		if and(get(anchors tag(NAME)) neq(get(anchors tag(NAME)) $this-file))
			warning("Anchor $[NAME] ambiguous (first time in get(anchors $[NAME]))")
		else
			put anchors $[NAME] $this-file
		endif
	else
		insert anchors $[NAME] $this-file
	endif
	writetag A NAME "$[NAME]";
}

tag "HREF"
{
	flush-buffer()
	def location;
	if tag(LOCATION)
		if isprefix(tag(LOCATION) '#')
			if check(anchors substr($[LOCATION] 1))
				set location = get(anchors substr($[LOCATION] 1))$[LOCATION]
			else 
				insert anchors substr($[LOCATION] 1) ''
				set location = $[LOCATION]
			endif
		else
			set location = tag(LOCATION);
		endif
	else
		translatez(reset(chkhref) tag(VALUE))
		switch statename(chkhref Href_)
			when eq($^ Href_Man)
				set location = translate(reset(man2url) tag(VALUE))
				breaksw
			when eq($^ Href_Mail)
				set location = "mailto:$[VALUE]"
				breaksw
			when eq($^ Href_URL)
				set location = tag(VALUE)
		endsw
	endif
	writetag A HREF translate(html $location);
	set buffer = cond(tag(VALUE) translate(html tag(VALUE)) "*")
	flush-buffer()
	writetag /A;
}

std-tag()
{
	flush-buffer()
	writetag;
}

tag "EM" { std-tag() }
tag "/EM" { std-tag() }
tag "STRONG" { std-tag() }
tag "/STRONG" { std-tag() }
tag "SAMPLE" { settag '' SAMP std-tag() }
tag "/SAMPLE" { settag '' /SAMP std-tag() }
tag "VAR" { std-tag() }
tag "/VAR" { std-tag() }
tag "CODE" { std-tag() }
tag "/CODE" { std-tag() }

tag "WATERMARK" { flush-buffern() ioctl outstream() raw write '<!-- ' ioctl outstream() cooked }
tag "/WATERMARK" { flush-buffer() ioctl outstream() raw write '-->\n' ioctl outstream() cooked }

tag "P"
{
	flush-buffern();
	writetag;
	write \n
}

tag "INDENT"
{
	flush-buffern()
	if $indenting
		writetag /TD;
		writetagn /TR;
	else
		writetagn TABLE;
		set indenting = true
	endif
	writetag TR;
	writetag TD VALIGN TOP;
	ioctl outstream() raw
	write translate(reset(protect) tag(LABEL))
	ioctl outstream() cooked
	writetag /TD;
	writetag TD
}

tag "NOINDENT"
{
	if $indenting
		flush-buffern()
		writetag /TD;
		writetagn /TR;
		writetagn /TABLE;
		clear indenting
	endif
}

tag "LIST"
{
	flush-buffern();
	if $indenting 
		writetag /TD;
		writetagn /TR;
		writetagn /TABLE;
		clear indenting
	endif
	prefix 'listguess:'
}

tag "listguess:ITEM"
{
	if tag(LABEL)
		push(in-list = DL)
	else
		push(in-list = UL)
	endif
	flush-buffern()
	writetag $in-list;
	prefix ''
	dispatch
}

tag "listguess:/LIST"
{
	flush-buffern();
	prefix ''
}

tag "ITEM"
{
	if eq($in-list UL)
		flush-buffern()
		writetagn LI;
	else
		flush-buffern()
		writetag DT;
		ioctl outstream() raw
		write translate(reset(protect) tag(LABEL))\n
		ioctl outstream() cooked
		writetagn /DT;
		writetagn DD;
	endif	
}

tag "/LIST"
{
	flush-buffern()
	writetagn cond(eq($in-list UL) /LI /DD);
	writetagn /$in-list;
	pop in-list
}

tag "PRE"
{
	if tag(INLINE)
		set pre = inline
	else
		set pre = true;
		writetagn PRE;
	endif
	prefix 'pre:'
}

tag "pre:/PRE"
{
	ctranslate(reset(pre) $tabsize)
	set buffer = translate(pre $buffer)
	flush-buffer()
	if neq($pre inline)
		writetagn /PRE;
	endif
	clear pre
	prefix ''
}

writetag(id)
{
	using dsh_$id
	if not($[])
		writestr($id $[value])
	else
		outstream $cur-out
		if not($in-body) start-body() endif
		dispatch
	endif
}

ioctl(id ctl)
{
	using dsh_$id
	if eq($ctl divert)
		flush-buffer()
		clear divert
		set cur-out = divert:$id
	elsif eq($ctl nodivert)
		flush-buffer()
		set cur-out = out:$id
	elsif eq($ctl insdiv)
		flush-buffer()
		ioctl $cur-out raw
		writeto $cur-out $divert 
		ioctl $cur-out cooked
	elsif eq($ctl flush)
		flush-buffern()
	elsif eq($ctl quiet)
		set quiet = true
	elsif isprefix($ctl option=)
		set ctl = substr($ctl length(option=))
		if isprefix($ctl width=)
			set linewidth = substr($ctl length(width=))
		elsif isprefix($ctl tabsize=)
			set tabsize = substr($ctl length(tabsize=))
		elsif isprefix($ctl title=)
			set title = substr($ctl length(title=))
		elsif isprefix($ctl language=)
			set doc-lang = substr($ctl length(language=))
		elsif isprefix($ctl encoding=)
			set doc-enc = substr($ctl length(encoding=))
		elsif isprefix($ctl author=)
			set author = substr($ctl length(author=))
		elsif isprefix($ctl hrefdump=)
			if not($hrefdump)
				set hrefdump = $(outprefix)substr($ctl length(hrefdump=))
				if exists($hrefdump)
					defstream hrefs $hrefdump basic;
					defautoseq rl linefilter
					def line anch file;
					while set(line readfrom(hrefs rl))
						set file = split($line \t '' anch)
						if check(anchors $anch) 
							if neq(get(anchors $anch) $file)
								warning("Filename conflict for $anch");
							endif
						else
							insert anchors $anch $file
						endif
					loop
					rmstream hrefs
					rmautoseq rl
				endif
			endif
		elsif or(isprefix($ctl meta=) isprefix($ctl http=))
			if not($in-body)
				def name content;
				set content = split($ctl '=' '' ctl name);
				writetagn META cond(eq($ctl meta) NAME HTTP-EQUIV) $name CONTENT $content;
			endif
		endif
	endif
}
