#
# 	Copyright (C) 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.ifhas ::module::time
.module <time>
.endif
.automaton docstrip_man
.define true -1;
.define Protect 1;
.define Unbold 2;
.define Unitalic 3;
.define UnBoldItalic 4;
.define ub_first 200;
.define ub_other 201;
.define ui_first 300;
.define ui_other 301;
.define ubi_first 400;
.define ubi_other 401;
.define Pre 5;
.define NON_JOINER 0x7F;
.start Protect;

.define after_dash 100;
.define after_dash2 101;
.define after_paren 102;
.define after_exclam 103;
.define after_less 104;
.define after_tilde 105;
.define after_equal 107;
.define after_parenc 108;
.define after_greater 109;
.define after_plus 110;
.define after_lessd 111;
.define after_lessd2 112;
.define after_lesse 113;
.define after_lesse2 114;
.define after_equal2 115;
Protect; $$ = '.'; true; Protect; { "\\&\\." }{}
Protect; $$ = '\''; true; Protect; { "\\(cq" }{}
Protect; $$ = '\"'; true; Protect; { "\\(dq" }{}
Protect; $$ = '\\'; true; Protect; { "\\(rs" }{}
Protect; $$ = '-'; true; after_dash; {}{}
Protect; $$ = '~'; true; after_tilde; {}{}
Protect; $$ = '<'; true; after_less; {}{}
Protect; $$ = '('; true; after_paren; {}{}
Protect; $$ = '='; true; after_equal; {}{}
Protect; $$ = '+'; true; after_plus; {}{}
Protect; $$ = '>'; true; after_greater; {}{}
Protect; $$ = NON_JOINER; true; Protect; {}{} 
Protect; true; true; Protect; { $$; }{}
after_dash; $$ = '-'; true; after_dash2; {}{}
after_dash; $$ = '>'; true; Protect; { "\\(->" }{}
after_dash; ^true; true; Protect; { "\\-" }{}
after_dash2; $$ = '-'; true; Protect; { "\\(em" }{}
after_dash2; $$ = '>'; true; Protect; { "\\(->" }{}
after_dash2; ^true; true; Protect; { "\\(en" }{}
after_tilde; $$ = '~'; true; Protect; { '~'; }{}
after_tilde; ^true; true; Protect; { "\\ " }{}
after_paren; $$ = 'c' || $$ = 'C'; true; after_parenc; {}{ $$; }
after_paren; ^true; true; Protect; { '('; }{}
after_parenc; $$ = ')'; true; Protect; { "\\(co" }{}
after_parenc; ^true; true; Protect; { '('; $1; }{}
after_exclam; $$ = '='; true; Protect; { "\\(!=" }{}
after_exclam; ^true; true; Protect; {}{}
after_less; $$ = '-'; true; after_lessd; {}{}
after_less; $$ = '='; true; after_lesse; {}{}
after_less; ^true; true; Protect; { '<'; }{}
after_lessd; $$ = '-'; true; after_lessd2; {}{}
after_lessd; $$ = '>'; true; Protect; { "\\(<>" }{}
after_lessd; ^true; true; Protect; { "\\(<-" }{}
after_lessd2; $$ = '>'; true; Protect; { "\\(<>" }{}
after_lessd2; ^true; true; Protect; { "\\(<-" }{}
after_lesse; $$ = '='; true; after_lesse2; {}{}
after_lesse; $$ = '>'; true; Protect; { "\\(hA" }{}
after_lesse; ^true; true; Protect; { "\\(<=" }{}
after_lesse2; $$ = '>'; true; Protect; { "\\(hA" }{}
after_lesse2; ^true; true; Protect; { "\\(lA" }{}
after_equal; $$ = '>'; true; Protect; { "\\(>=" }{}
after_equal; $$ = '='; true; after_equal2; {}{}
after_equal; ^true; true; Protect; { '='; }{}
after_equal2; $$ = '>'; true; Protect; { "\\(rA" }{}
after_equal2; ^true; true; Protect; { "==" }{}
after_plus; $$ = '-'; true; Protect; { "\\(+-" }{}
after_plus; ^true; true; Protect; { '+'; }{}
after_greater; $$ = '='; true; Protect; { "\\(>=" }{}
after_greater; ^true; true; Protect; { '>'; }{}

Unbold; $$ = '\2'; true; ub_first; { ".BR " }{}
Unbold; $$ = '\1'; true; Unbold; {}{}
Unbold; true; true; ub_other; { ".RB " $$; } {}
ub_first; $$ = '\2'; true; ub_other; { "\"\" "}{}
ub_first; $$ = '\1'; true; ub_other; {}{}
ub_first; true; true; ub_other; { $$; }{}
ub_other; $$ = '\2'; true; ub_first; {  ' '; }{}
ub_other; $$ = '\1'; true; ub_other; {}{}
ub_other; true; true; ub_other; { $$; }{}

Unitalic; $$ = '\1'; true; ui_first; { ".IR " }{}
Unitalic; $$ = '\2'; true; Unitalic; {}{}
Unitalic; true; true; ui_other; { ".RI " $$; } {}
ui_first; $$ = '\1'; true; ui_other; { "\"\" "}{}
ui_first; $$ = '\2'; true; ui_other; {}{}
ui_first; true; true; ui_other; { $$; }{}
ui_other; $$ = '\1'; true; ui_first; {  ' '; }{}
ui_other; $$ = '\2'; true; ui_other; {}{}
ui_other; true; true; ui_other; { $$; }{}


UnBoldItalic; $$ = '\1'; true; ubi_first; { ".IB " }{}
UnBoldItalic; $$ = '\2'; true; ubi_first; { ".BI " }{}
UnBoldItalic; true; true; ubi_other; { ".BI " $$; }{}
ubi_first; $$ = '\1' || $$ = '\2'; true; ubi_other; { "\"\" " }{}
ubi_first; true; true; ubi_other; { $$; }{}
ubi_other; $$ = '\1' || $$ = '\2'; true; ubi_first; { ' '; }{}
ubi_other; true; true; ubi_other; { $$; }{}

Pre; $$ = ' '; true; Pre; { "\\ " }{}
Pre; $$ = '\n'; true; Pre; { "\n.br\n"}{}
Pre; $$ = '.'; true; Pre; { "\\&\\." }{}
Pre; $$ = '\''; true; Pre; { "\\(cq" }{}
Pre; $$ = '\"'; true; Pre; { "\\(dq" }{}
Pre; $$ = '\\'; true; Pre; { "\\(rs" }{}
Pre; $$ = '-'; true; Pre; { "\\-" }{}
Pre; true; true; Pre; { $$; }{}
.end

.ifhasnt timestamp
get-time() { return(builddate()) }
.else
get-time() { return(ascii-time(timestamp())) }
.endif

streamopen(id arg writable)
{
	defstream out:$id file://$arg basic true;
	outstream out:$id
	pool dsm_$id
	using dsm_$id
	shared linewidth = 80 this-word wordsep = '\n' italic bold keep-line italic-cnt bold-cnt;
	shared preformat buffer inline indenting in-list need-par after-nl;
	shared divert divert-need-par cur-out = out:$id;
	defstream divert:$id inline://dsm_$id/divert basic true
	def name section;
	split(reverse($arg) . / section name)
	write ".TH \"reverse($name)\" \"reverse($section)\" \"(get-time())\"\n"
	once({
		defautoseq protect docstrip_man:Protect
		defautoseq unbold docstrip_man:Protect|docstrip_man:Unbold
		defautoseq unitalic docstrip_man:Protect|docstrip_man:Unitalic
		defautoseq unbolditalic docstrip_man:Protect|docstrip_man:UnBoldItalic
		defautoseq pre docstrip_man:Pre
	})
}

streamclose(id)
{
	using dsm_$id
	outstream $cur-out
	flush-all()
	rmstream out:$id
	rmstream divert:$id
	rmpool dsm_$id
}

read(id)
{
	error "cannot read from here"
}

flush-word()
{
	if neq(int 0 $italic-cnt)
		flush-buffer()
		if eq(int 0 $bold-cnt)
			write translatez(reset(unitalic) $this-word)\n
		else
			if or(isprefix($this-word \1) isprefix($this-word \2))
				write translatez(reset(unbolditalic) $this-word)\n
			elsif greater(int $italic-cnt $bold-cnt)
				write translatez(reset(unitalic) $this-word)\n
			else
				write translatez(reset(unbold) $this-bold)\n
			endif
		endif
	elsif neq(int 0 $bold-cnt)
		flush-buffer()
		write translatez(reset(unbold) $this-word)\n
	else
		set buffer = $buffer$this-word' '
	endif
	if $italic
		set this-word = \1
		set italic-cnt = 1
	else
		clear italic-cnt
		clear this-word
	endif
	if $bold
		set this-word = $this-word\2
		set bold-cnt = 1
	else
		clear bold-cnt
	endif	
	if ge(int length($buffer) $linewidth)
		flush-buffer()
	endif
}

flush-buffer()
{
	if and(not($inline) set(buffer trim($buffer)))
		if eq(prefix() "watermark:")
			write ".\\\" "
		endif
		write translatez(protect $buffer)\n
		clear buffer
	endif
}

flush-all()
{
	if $this-word flush-word() endif
	clear inline
	flush-buffer()
}

writestr(id str)
{
	if not($str) return endif
	using dsm_$id;
	outstream $cur-out
	if $preformat
		write translate(pre $str)
		set after-nl = issuffix($str \n)
		return
	endif
	if $need-par
 		write cond($indenting .IP\n .P\n)
		clear need-par 
	endif
	def word complete = issuffix($str ' ');
	while $str;
		set str = split($str ' ' '' word)
		set this-word = $this-word$word
		if or($str $complete)
			flush-word()
		endif
	loop
}

tag "P"
{
	flush-all()
	clear need-par
	write cond($indenting ".IP\n" ".P\n")
}

tag "INDENT"
{
	flush-all()
	write ".IP \"translatez(protect tag(LABEL))\" cond(less(int length(tag(LABEL)) 10) 10 add(3 length(tag(LABEL))))\n"
	clear need-par
	set indenting = true
}

tag "NOINDENT"
{
	clear indenting
}

tag "LIST"
{
	clear need-par
	push(indenting = true)
	if $in-list flush-all() write ".RS\n" endif
	set in-list = +$in-list
}

tag "ITEM"
{
	flush-all()
	write ".IP cond(tag(LABEL) \"translatez(protect $[LABEL])\"\ add(length($[LABEL]) 3) '\\(bu 4')\n"
}

tag "/LIST"
{
	pop indenting
	flush-all()
	set in-list = substr($in-list 1)
	if $in-list write ".RE\n" endif
	set need-par = true
}

heading(cmd)
{
	flush-all()
	clear need-par
	clear indenting
	set inline = true
	write $cmd\n
}

tag "H1"
{
	heading(.SH)
}

tag "H2"
{
	heading(.SS)
}

tag "H3"
{
	heading(.TP\n.B)
}

tag "/H[123]"
{
	flush-all()
}

tag "EM"
{
	if $inline return endif
	if not($italic)
		set this-word = $this-word\1
		incr italic-cnt 1
	endif
	set italic = $italic+
}

tag "/EM"
{
	if $inline return endif
	set italic = substr($italic 1)
	if not($italic)
		set this-word = $this-word\1
		incr italic-cnt 1
	endif
}

tag "STRONG"
{
	if $inline return endif
	if not($bold)
		set this-word = $this-word\2
		incr bold-cnt 1
	endif
	set bold = $bold+
}

tag "/STRONG"
{
	if $inline return endif
	set bold = substr($bold 1)
	if not($bold)
		set this-word = $this-word\2
		incr bold-cnt 1
	endif
}

tag "SAMPLE"
{
	settag '' STRONG
	dispatch
}

tag "/SAMPLE"
{
	settag '' /STRONG
	dispatch
}

tag "VAR"
{
	settag '' EM
	dispatch
}

tag "/VAR"
{
	settag '' /EM
	dispatch
}

tag "HREF"
{
	settag '' EM
	dispatch
	writestr(substr(using() length(dsm_)) tag(VALUE))
	settag '' /EM
	dispatch
}

tag "PRE"
{
	flush-all()	
	if not(tag(INLINE))
		write ".P\n"
		set preformat = true
	else
		set preformat = inline
	endif
	prefix pre:
}

tag "pre:/PRE"
{
	prefix ''
	if neq($preformat inline)
		set need-par = true
		if not($after-nl) write \n endif
	endif
	clear preformat
}

tag "WATERMARK"
{
	flush-all()
	prefix 'watermark:'	
}

tag "watermark:/WATERMARK"
{
	flush-all()
	prefix ''
}

writetag(id)
{
	using dsm_$id
	if not($[])
		writestr($id $[value])
	else		
		outstream $cur-out
		dispatch
	endif
}

ioctl(id ctl)
{
	using dsm_$id
	if eq($ctl divert)
		flush-all()
		clear divert
		set cur-out = divert:$id
	elsif eq($ctl nodivert)
		flush-all()
		set divert-need-par = $need-par
		clear need-par
		set cur-out = out:$id
	elsif eq($ctl insdiv)
		flush-all()
		writeto $cur-out $divert
		set need-par = $divert-need-par
	elsif eq($ctl flush)
		flush-all()
	elsif isprefix($ctl option=)
		set ctl = substr($ctl length(option=))
		if isprefix($ctl width=)
			set linewidth = substr($ctl length(width=))
		elsif isprefix($ctl author=)
			flush-all()
			write ".\\\" substr($ctl length(author=))\n"
		endif
	endif
}
