.automaton eatspace
.define true -1;
.define Start 1;
.define after_tilde 2;
.start Start;
.final Start;

Start; $$@[' ', '\t', '\n', '\r'] >= 0; true; Start; { ' '; }{}
Start; $$ = 0x7F; true; Start; {}{}
Start; $$ = '~'; true; after_tilde; {}{}
Start; true; true; Start; { $$; }{}
after_tilde; $$ = '~'; true; Start; { '~'; }{}
after_tilde; ^true; true; Start; { ' '; }{}
.end

streamopen(id arg writeable)
{
	pool dsp_$id
	using dsp_$id
	shared buffer linewidth = 80 tabsize = repeat(' ' 4) nowrap indent pre curout = out:$id;
	shared diversion watermark nohilite;
	defstream div:$id "inline://dsp_$id/diversion" basic true
	defstream out:$id cond(isprefix($arg inline://) $arg file://$arg) basic true;
	once({
		defautoseq eatspace eatspace
		global list-syms = *+-o.;
		readonly list-syms
	})
}

read(id)
{
	error "cannot read from here"
}

flush-buffer()
{
	if $buffer
		write translate(eatspace $buffer)\n
	endif
	set buffer = $indent
}

streamclose(id)
{
	using dsp_$id
	outstream out:$id
	flush-buffer()
	rmstream out:$id
	rmpool dsp_$id
}


writestr(id str)
{
	using dsp_$id
	if $watermark return endif
	outstream $curout
	if $pre write substit($str \t $tabsize) return endif
	if $nowrap set buffer = $buffer$str return endif
	def idx wrd ch;
	while $str
		set ch = substr($str 0 1)
		set str = substr($str 1)
		set buffer = $(buffer)$ch
		if ge(int length($buffer) $linewidth)
			set idx = rindex($buffer ' ')
			if and($idx trim(substr($buffer 0 $idx)))
				set wrd = substr($buffer add($idx 1))
				set buffer = substr($buffer 0 $idx)
				flush-buffer()
				if trim($wrd)
					set buffer = $(buffer)$wrd
				endif
			endif
		endif
	loop
}

flush-header(ch)
{
	def underline = repeat($ch length($buffer));
	flush-buffer()
	write $underline\n\n
	clear nowrap
}

writetag(id)
{
	using dsp_$id
	if $watermark 
		if eq($[] /WATERMARK)
			clear watermark
		endif
	endif
	outstream $curout
	switch $[]
		case 'H[1234]'
			set nowrap = true
			clear indent
			flush-buffer()
			write \n
			breaksw
		when eq($[] /H1)
			flush-header(*)
			breaksw
		when eq($[] /H2)
			flush-header(=)
			breaksw
		when eq($[] /H3)
			flush-header(-)
			breaksw
		when eq($[] /H4)
			flush-buffer()
			write \n
			breaksw
		when eq($[] EM)
		when eq($[] /EM)
			if not($nohilite) writestr($id _) endif
			breaksw
		when eq($[] STRONG)
		when eq($[] /STRONG)
			if not($nohilite) writestr($id *) endif
			breaksw
		when eq($[] SAMPLE)
		when eq($[] CODE)
		when eq($[] VAR)
			if not($nohilite) writestr($id \`) endif
			breaksw
		when eq($[] /SAMPLE)
		when eq($[] /CODE)
		when eq($[] /VAR)
			if not($nohilite) writestr($id \') endif
			breaksw
		when eq($[] HREF)
			if tag(VALUE)
				writestr($id tag(VALUE))
			elsif not(isprefix(tag(LOCATION) '#'))
				writestr($id <tag(LOCATION)>)
			endif
			breaksw
		when eq($[] P)
			flush-buffer()
			write \n
			breaksw
		when eq($[] INDENT)
			clear indent
			flush-buffer()		
			set indent = $tabsize
			if tag(LABEL)
				set buffer = replace($indent 0 add(1 length(tag(LABEL))) tag(LABEL)' ')
			else
				set buffer = $indent
			endif
			breaksw
		when eq($[] NOINDENT)
			clear indent
			flush-buffer()
			breaksw
		when eq($[] LIST)
			push(indent = $indent$tabsize)
			breaksw
		when eq($[] ITEM)
			def label = cond(tag(LABEL) tag(LABEL) substr($list-syms sub(depth(indent) 2) 1));
			flush-buffer()
			def pos = sub(length($buffer) add(1 length($label)));
			if less(int $pos 0) set pos = 0 endif
			set buffer = replace($buffer $pos length($label) $label)
			breaksw
		when eq($[] /LIST)
			pop indent
			flush-buffer()
			breaksw
		when eq($[] WATERMARK)
			set watermark = true
			breaksw
		when eq($[] PRE)
			flush-buffer()
			clear buffer
			if tag(INLINE)
				set pre = inline
				write \n
			else
				set pre = true
			endif
			breaksw
		when eq($[] /PRE)
			if neq($pre inline)
				write \n
				set buffer = $indent
			endif
			clear pre
			breaksw			
	endsw
}

ioctl(id ctl)
{
	using dsp_$id
	if eq($ctl divert)
		flush-buffer()
		clear buffer
		clear diversion
		set curout = div:$id
	elsif eq($ctl nodivert)
		flush-buffer()
		set curout = out:$id
	elsif eq($ctl insdiv)
		flush-buffer()
		writeto $curout $diversion
	elsif eq($ctl flush)
		flush-buffer()
	elsif isprefix($ctl option=)
		set ctl = substr($ctl length(option=));
		if isprefix($ctl width=)
			set linewidth = substr($ctl length(width=))
		elsif isprefix($ctl tabsize=)
			set tabsize = repeat(' ' substr($ctl length(tabsize=)))
		elsif isprefix($ctl nohilite)
			set nohilite = true
		endif
	endif
}

getpos(id)
{
	return(getpos(out:$id))	
}

