#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

main
{
	global ch_trans = '';
	if eq(get(ARGV 2) utf8)
		subload utf8html utf8html
		defstream ins utf8html?get(ARGV 1) script;
		ioctl ins pass=keepspaces
	else
		defstream ins get(ARGV 1) html;
		ioctl ins keepspaces
		set ch_trans = win2koi
	endif
	defautoseq translator intconv:FromInt|koi8r:Tonative|koi8r:ToTeX
	defautoseq win2koi cp1251:Tounicode|koi8r:Tonative|koi8r:ToTeX
	instream ins
	table ent +ent2tex
	table entities +entities
	table codes ''
	def iter;
	foreach iter entities
		insert codes get(entities $iter) get(ent $iter)
	loop
	prefix 'header:'
	global first_row first_col multicolumn;
}

tag "header:BODY" { prefix '' }

non-null(val)
{
	if not(trim($val))
		def x;
		set x = translatez(reset(translator) $[value])
		echo "???? $[value] -> ($x)"
		write $x
	else
		write $val
	endif
}


tag "&"
{
	prefix ''
	if check(ent $[value])
		non-null(get(ent $[value]))
	elsif check(codes $[value])
		non-null(get(codes $[value]));
	else
		def x;
		set x = translatez(reset(translator) $[value])
		write $x
		if not($x) echo "????? $[value]" endif
	endif
}

tag "P"
{
	prefix after-nl:
	write \n\n
}

tag "I"
{
	prefix ''
	write '\\textit{'
}

tag "/[IBU]"
{
	prefix ''
	write '}'
}

tag "B"
{
	prefix ''
	write '\\textbf{'
}

tag "U"
{
	prefix ''
	write '\\underline{'
}

tag "H1"
{
	prefix ''
	write '\\chapter{'
}

tag "H2"
{
	prefix ''
	write '\\section{'
}

tag "/H[12]"
{
	prefix ''
	write '}\n'
}

tag "TABLE"
{
	write '\\begin{tabular}{} % fill in the second arg yourself\n'
	push(first_row = true)
	push(first_col = true)
	push multicolumn
}

tag "TD"
{
	if tag(COLSPAN)
		write '\\multicolumn{'tag(COLSPAN)'}{}{'
		set multicolumn = true
	else
		if $multicolumn write '}' set multicolumn = '' endif
		if not($first_col) write " & " endif
		set first_col = ''
	endif
}

tag "TR"
{
	if $multicolumn write '}' set multicolumn = '' endif
	if not($first_row) write "\\\\\n" endif
	set first_row = ''
	set first_col = true
}

tag "TH"
{
	set first_row = ''
	settag '' TD
	dispatch
}

tag "/TABLE"
{
	pop first_col
	pop first_row
	pop multicolumn
	write '\\end{tabular}\n';
}

tag "OL"
{
	write '\\begin{enumerate}\n'
}

tag "UL"
{
	write '\\begin{itemize}\n'
}

tag "/UL"
{
	write '\\end{itemize}\n'
}

tag "/OL"
{
	write '\\end{enumerate}\n'
}

tag "LI"
{
	write '\\item \n'
}

tag "!\\["
{
	ioctl instream() raw
	prefix 'section-ignore:'
}

char "section-ignore:]"
{
	prefix 'section-ignore1:'
}

char "section-ignore1:>"
{
	ioctl instream() cooked
	prefix ''
}

char "section-ignore1:?"
{
	prefix 'section-ignore:'
}

char "\n"
{
	prefix 'after-nl:'
	writetag;
}

char "after-nl:[[:space:]]" {}
char "after-nl:?" { prefix '' dispatch }
tag "after-nl:*" { dispatch('') }

char "?"
{
	write translate($ch_trans $[value]);
}
