#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.include <mailbox.sci>
.ifhas ::module::time
.module <time>
.else
timestamp
{
	return(0)
}
.endif

safe-sql(subcmd arg;)
{
	call sql $subcmd $arg;
	if sql(error)
		error "SQL error: sql(error)"
	endif
}

main
{
	if not(getenv(GATEWAY_VERSION))
		defstream ins '' html;
		instream ins
	endif
	global reason;
	read
	onerror error-handler
	table database get(ARGV 1)
	table record ''
	def handle key body dflt;
	make-automata()
	set key = sto.enum(database handle field_)
	while isprefix($key field_)
		set dflt = get(database $key)
		set key = substr($key length(field_))
		if eq($key timestamp) settag $key timestamp() endif
		if not(tag($key)) settag $key $dflt endif
		if or(and(conditions($key notnull) not(tag($key)))
			  and(conditions($key null) tag($key)))
			write "Content-Type: text/html"
			write ""
			writetag HTML;
			writetag BODY;
			writetag H1;
			write "$reason"
			writetag /H1;
			writetag /BODY;
			writetag /HTML;
			exit
		endif
		insert record $key translatez(
			cond(check(database trn_$key) 
					defautoseq(* get(database trn_$key))
				) tag($key)
			)
		set key = sto.enum(database handle)
	loop
	if $handle sto.break(database handle) endif
	if check(database sql)
		set key = expand(get(database sql_query) record)
		module get(database sql)
		safe-sql connect expand(get(database sql_connect) record);
		safe-sql exec $key;
		safe-sql disconnect;
	else
		set key = expand(get(database template) record)
		set body = expand(get(database bodytemplate) record)
		table datatable get(database datatable)
		if not(check(database $key))
			insert datatable $key $body
		else	
			put datatable $key get(database $key)$body
		endif
	endif
	write "Location: cond(get(ARGV 2) get(ARGV 2) getenv(HTTP_REFERER))"
	write ""
}

make-automata()
{
	def handle key body;
	set key = sto.enum(database handle field_)
	while isprefix($key automaton_)
		set body = get(database $key)
		set key = substr($key automaton_)
		au.new $key
		au.build $key $body
		set key = sto.enum(database handle)
	loop
	if $handle sto.break(database handle) endif
}

conditions(key cond)
{
	if not(check(database fld_$(key)_$cond)) return endif 
	def deps = get(database fld_$(key)_$cond) dep fld val op = eq;
	if not($deps) 
		set reason = "Field \'$key\' must cond(neq($cond null) not) be empty"
		return(true) 
	endif
	while $deps
		set deps = split($deps ' ' '' dep)
		if $dep
			if isprefix($dep !) set dep = substr($dep 1) set op = neq endif
			split($dep '=' '' fld val)
			if call($op tag($fld) $val) 
				set reason = 
"Field \'$key\' must cond(neq($cond null) not) be empty if \'$fld\' is cond(eq($op neq) not) cond($val 'equal to '\'$val\' 'empty')"			
				return(true) 
			endif
		endif
	loop
}

error-handler(desc lno ...)
{
	write "Status: 500 Internal Server Error"
	write "Content-Type: text/html"
	write ""
	writetag HTML;
	writetag BODY;
	writetag H1;
	write "An error occurred";
	writetag /H1;
	write \n
	writetag P;
	write "$desc at line $lno\n"
	writetag /BODY;
	writetag /HTML;
	exit
}
