#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.do { 
	defautoseq lf linefilter
	defautoseq emailtrn emailtrn
	defautoseq unquote emailtrn:Unquote
	defautoseq tolower ascii:Tolower
	defstream mailbox '' basic;
}

nextmail(pos)
{
	setpos mailbox $pos
	def line;
	readfrom(mailbox lf)
	while;
		set pos = getpos(mailbox)
		set line = readfrom(mailbox lf)
		if iseof() return endif
	loop(not(isprefix($line 'From ')))
	return($pos)
}

nextpart(pos boundary)
{
	setpos mailbox $pos
	def line;
	while;
		set(line readfrom(mailbox lf))
		if isprefix($line --$(boundary)--) return endif
		if isprefix($line --$boundary) return(getpos(mailbox)) endif
	loop
}

endofpart(pos boundary)
{
	setpos mailbox $pos
	def line;
	while;
		set pos = getpos(mailbox)
		set(line readfrom(mailbox lf))
		if isprefix($line --$(boundary)--) return($pos) endif
		if isprefix($line --$boundary) return($pos) endif
	loop
}

nthmail(no)
{
	def pos = 0;
	while neq(int 0 $no)
		set pos = nextmail($pos)
		decr no 1
	loop($pos)
	return($pos)
}

lastmail()
{
	def no pos = 0 tmp;
	rewind mailbox
	while set(tmp nextmail($pos)) set pos = $tmp incr no 1 loop
	return("$no $pos")
}

mailbody(pos)
{
	setpos mailbox $pos
	while readfrom(mailbox lf) loop;
	set pos = getpos(mailbox)
	return($pos)
}

headerfld(pos hdr)
{
	setpos mailbox $pos
	def line line1;
	while set(line readfrom(mailbox lf))
		if isprefix(translate(tolower $line) $hdr\:)
			set line = substr($line length($hdr\:))
			while;
				set line1 = readfrom(mailbox lf)
				if and(not(isprefix($line1 ' ')) not(isprefix($line1 '\t')))
					break
				endif
				set line = $line$line1
			loop
			break
		endif
	loop
	return(trim(translate(reset(emailtrn) $line)))
}

gethdrparam(hdrbody fld)
{
	def idx = indexi($hdrbody $fld=);
	if not($idx) return endif
	def val; 
	ausplit(substr($hdrbody add($idx length($fld) 1)) reset(unquote) <none> val)
	set val = translate(unquote $val)
	return($val)
}

setmailbox(mbox)
{
	import stream __mailbox $mbox
	release stream mailbox
	rename stream __mailbox mailbox
}

.do
{
	export proc nextmail mail:nextmail
	export proc nextpart mail:nextpart
	export proc endofpart mail:endofpart
	export proc mailbody mail:mailbody
	export proc nthmail   mail:nthmail
	export proc lastmail  mail:lastmail
	export proc headerfld  mail:headerfld
	export proc setmailbox mail:setmailbox
	export proc gethdrparam mail:gethdrparam
}
