#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

set.add(set1 set2)
{
	def iter;
	foreach iter $set2
		if not(check($set1 $iter))
			insert $set1 $iter get($set2 $iter)
		endif
	loop
	return($set1)
}

set.subtract(set1 set2)
{
	def iter;
	foreach iter $set2
		if check($set1 $iter)
			remove $set1 $iter
		endif
	loop
	return($set1)
}

set.intersect(set1 set2)
{
	def iter;
	foreach iter $set1
		if not(check($set2 $iter))
			mark-remove($set1 $iter)
		endif
	loop
	do-remove($set1)
	return($set1)
}

set.includes(set1 set2)
{
	def iter;
	foreach iter $set1
		if not(check($set2 $iter))
			return
		endif
	loop
	return(true)
}

set.overlaps(set1 set2)
{
	def iter;
	foreach iter $set1
		if check($set2 $iter)
			return(true)
		endif
	loop
}

iset.additem(set1 no)
{
	set set1 = replace(pad($set1 neg(add($no 1))) $no 1 x)
	return($set1)
}

iset.delitem(set1 no)
{
	set set1 = replace(pad($set1 neg(add($no 1))) $no 1 ' ')
	return($set1)
}

iset.isin(no set1)
{
	return(eq(x substr($set1 $no 1)))
}

iset.union(set1 set2)
{
	def r;
	while and($set1 $set2)
		if or(eq(substr($set1 0 1) x) eq(substr($set2 0 1) x))
			set r = $(r)x
		else
			set r = $r' '
		endif
		set set1 = substr($set1 1)
		set set2 = substr($set2 1)
	loop
	return($(r)cond($set1 $set1 $set2))
}

iset.intersect(set1 set2)
{
	def r;
	while and($set1 $set2)
		if and(eq(substr($set1 0 1) x) eq(substr($set2 0 1) x))
			set r = $(r)x
		else
			set r = $r' '
		endif
		set set1 = substr($set1 1)
		set set2 = substr($set2 1)
	loop
	return($(r))
}

iset.includes(set1 set2)
{
	while and($set1 $set2)
		if and(eq(substr($set1 0 1) x) neq(substr($set2 0 1) x))
			return
		endif
		set set1 = substr($set1 1)
		set set2 = substr($set2 1)
	loop
	return(not(trim($set1)))
}