#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.pool DEFAULT
main
{
	defautoseq stringize escape
	global inner_switch curproc_name ifsaved_state; 
	shared initproc curproc;
	table procs ''	
	defstream in get(ARGV 1) xml;
	defstream out get(ARGV 1).sc basic true;
	defstream initproc 'inline://DEFAULT/initproc' basic true;
	instream in
	outstream out
	write '# Generated by TagMaster -- better do not edit manually\n\n'
	write 'handler\n{\n'
}

start-switch(type cond header=true)
{
	if not($inner_switch)
		set inner_switch = $type
		write "switch $header\n"
	elsif neq($inner_switch $type)
		write "when true\n"
		write "switch $header\n"
		push(inner_switch = $type)
	endif
	write "when $cond\n"
	push(inner_switch = '')
	prefix $type\:
}

end-switch(dobreak=true)
{
	if($inner_switch) 
		write endsw\n
	endif
	pop inner_switch
	prefix cond($inner_switch $inner_switch\:)
	if $dobreak
		write breaksw\n
	endif
}

tag "!--" {}

tag "*:!--"
{
}


tag "DEFINE"
{
	writeto initproc "global \'tag(NAME)\' cond(tag(VALUE) [= stringize(tag(VALUE))]);\n"
}

tag "MAP"
{
	writeto initproc "table \'tag(NAME)\' +\'tag(FILE)\'\n"
}

tag "TRANSLATOR"
{
	writeto initproc "defautoseq \'tag(NAME)\' \'tag(SEQ)\'\n"
}

tag "QUERY"
{
	def tmp = process-value(\$query\.tag(ARG));
	if not($tmp) set tmp = 'defined('tag(ARG)')' endif
	start-switch(query $tmp)
}

tag "STATE"
{
	def tmp = process-value('$:state');
	if not($tmp) set tmp = true endif
	start-switch(state $tmp)
}

tag "TAG"
{
	def tmp;
	if tag(COMMENT)
		set tmp = 'and(eq($[] !--) 'process-value('tag(comment)')')'
	elsif tag(XMLSPEC)
		set tmp = 'and(eq($[] ?) eq($[TARGET] 'stringize(tag(TARGET))') 'process-value('tag(rest)')')'
	elsif tag(SGMLSPEC)
		set tmp = 'and(eq($[] !) 'process-value('tag(rest)')')'
	elsif tag(SGMLSECT)
		set tmp = 'and(eq($[] \'![\') 'process-value('tag(SECTION)')')'
	elsif tag(ENTITY)
		set tmp = 'and(eq($[] \'&\') 'process-value('tag(value)')')'
	else
		set tmp = process-tag-desc()
	endif
	start-switch(tag $tmp) 
}

tag "/QUERY"
{
	end-switch(not(tag(PASS)))
}

tag "/STATE"
{
	end-switch(not(tag(PASS)))
}

tag "/TAG"
{
	end-switch(not(tag(PASS)))
}

tag "BLOCK"
{
	using DEFAULT
	insert procs set(curproc_name tag(NAME)) "user\-tag(NAME)(tag(ARG))\n\{\n"
	prefix 'block:'
	clear curproc
	defstream curproc "inline://DEFAULT/curproc" basic true;
	outstream curproc
}

tag "query:*" { dispatch('') }
tag "state:QUERY" { error 'Improper nesting: QUERY inside STATE' }
tag "state:*" { dispatch('') }
tag "tag:TAG" { dispatch('') }
tag "tag:/*" { dispatch('') }
tag "tag:*" { prefix 'tag2:' write 'switch true when not($:restart)\n' dispatch }

tag "tag2:/TAG"
{
	write endsw\n
	dispatch('')
}

tag "tag2:CHECKPOINT"
{
	write 'when eq($:restart 'tag(NAME)')\n'
}

tag "tag2:RESTART"
{
	def tmp;
	if tag(AT)
		set tmp = stringize(tag(AT))
	endif
	if tag(STATE)
		set tmp = $tmp\\\ stringize(tag(STATE))
	else
		set tmp = $tmp\\\ '$:state' 
	endif
	set tmp = $tmp\\\ cond(and(tag(THRESHOLD) isint(tag(THRESHOLD))) trim(tag(THRESHOLD)) '$:threshold')
	write 'return(restart\\ '$tmp')\n'
}

tag "tag2:NEXT"
{
	write 'return;\n'
}

tag "tag2:NEXTFILE"
{
	write 'return(nextfile)\n'
}

tag "tag2:ERROR"
{
	write 'message($:filename\\:\\ 'stringize(tag(TEXT))')\n'
	write 'return(nextfile)\n'
}

tag "tag2:SET"
{
	write 'set('stringize(tag(VAR))' 'process-set-value()')\n'
}

tag "tag2:CLEAR"
{
	if tag(FULL)
		write 'clear 'stringize(tag(VAR))';\n'
	else
		write 'set 'stringize(tag(VAR))' = \'\';\n'
	endif
}

tag "tag2:SAVE"
{
	write 'push('tag(VAR)' = $('tag(VAR)'))\n'
}

tag "tag2:RESTORE"
{
	write 'pop 'tag(VAR)'\n'
}

tag "tag2:INSERT"
{
	if tag(VALUE)
		write 'settag('stringize(tag(ATTR))' 'stringize(tag(VALUE))')\n'
	else
		write 'settag('stringize(tag(ATTR))' 'stringize(tag(NAME))')\n'
	endif
}

tag "tag2:RENAME"
{
	write 'settag(\'\' 'stringize(tag(TAG))')\n'
}

tag "tag2:DEFINE"
{
	write "def \'tag(NAME)\' cond(tag(VALUE) [= stringize(tag(VALUE))]);\n"
}

tag "tag2:DISCARD"
{
	if tag(ATTR)
		write 'rmtag('stringize(tag(ATTR))')\n'
	else
		write 'cleartag\n'
	endif
}

tag "tag2:EMIT"
{
	if tag(TEXT)
		if tag(RAW)
			write 'ioctl outstream() raw\n'
			write 'write 'stringize(tag(TEXT))';\n'
			write 'ioctl outstream() cooked\n'
		else
			write 'write 'stringize(tag(TEXT))';\n'
		endif
	elsif tag(COMMENT)
		write 'writetag !-- COMMENT 'stringize(tag(COMMENT))';\n'
	elsif tag(XMLSPEC)
		write 'writetag ? TARGET 'stringize(tag(TARGET))' REST 'stringize(tag(XMLSPEC))';\n'
	elsif tag(SGMLSPEC)
		write 'writetag ! REST 'stringize(tag(SGMLSPEC))';\n'
	elsif tag(ENTITY)
		write 'writetag & value 'stringize(tag(ENTITY))';\n'
	elsif tag(NAME)
		def tmp i;
		if tag(ATTR)
			set tmp = stringize(tag(ATTR))' 'cond(tag(VALUE) stringize(tag(VALUE)) stringize(tag(ATTR)))
		endif
		foreach i iota(8)
			incr i 1
			if tag(ATTR$i)
				set tmp = $tmp' 'stringize(tag(ATTR$i))' 'cond(tag(VALUE$i) stringize(tag(VALUE$i)) stringize(tag(ATTR$i)))
			else
				break
			endif
		loop
		write 'writetag 'stringize(tag(NAME))' '$tmp';\n'
	else
		write 'writetag;\n'
	endif
}

tag "tag2:USE"
{
	if index(tag(NAME) '$')
		write 'call user-'stringize(tag(NAME))' 'cond(tag(ARG) stringize(tag(ARG)))';\n'
	else
		write 'user-'tag(NAME)'('cond(tag(ARG) stringize(tag(ARG)))')\n'
	endif
}

tag "tag2:MAP"
{
	write 'table 'stringize(tag(NAME))' +'stringize(tag(FILE))';\n'
}

tag "tag2:/MAP"
{
	write "release storage stringize(tag(NAME))"
}

tag "tag2:TRANSLATOR"
{
	write "defautoseq stringize(tag(NAME)) stringize(tag(SEQ))\n"
}

tag "tag2:/TRANSLATOR"
{
	write "release autoseq stringize(tag(NAME))\n"
}

tag "tag2:RESET"
{
	write "reset stringize(tag(NAME))\n"
}

tag "tag2:MOVE"
{
	write 'setpos output 'stringize(tag(TO))';\n'
}

tag "tag2:ECHO"
{
	write 'message('stringize(tag(TEXT))');\n'
}

tag "tag2:IF"
{
	def tmp;
	if tag(VAR)
		set tmp = process-value('$('tag(VAR)')')
		if not($tmp)
			if tag(DEFINED)
				set tmp = 'defined('tag(VAR)')'
			else
				set tmp = '$('tag(VAR)')'
			endif
		endif
	elsif tag(MAP)
		set tmp = process-value('get('stringize(tag(MAP))' 'stringize(tag(ITEM))')')
		if not($tmp)
			set tmp = 'check('stringize(tag(MAP))' 'stringize(tag(ITEM))')'
		endif
	else
		error 'Invalid IF statement'
	endif
	write "if $tmp\n"
	push(ifsaved_state = prefix())
	prefix 'if:'
}

tag "if:/IF"
{
	write 'endif\n'
	prefix $ifsaved_state
	pop ifsaved_state
}

tag "if:ELSE"
{
	write 'else\n'
}

tag "if:CHECKPOINT"
{
	error "No checkpoints inside IF.../IF"
}

tag "if:TAG"
{
	error "No TAGs inside IF.../IF"
}

tag "if:*" { dispatch(tag2:) }

tag "block:CHECKPOINT"
{
	error 'No checkpoints within blocks'
}

tag "block:TAG"
{
	error 'No TAGs within blocks'
}

tag "block:/BLOCK"
{
	outstream out
	put procs $curproc_name get(procs $curproc_name)$curproc'\n}\n'
	rmstream curproc
	prefix ''
}

tag "block:*" { dispatch(tag2:) }

tag "*"
{
	error "Improper tag: $[]"
}

eof
{
	def iter;
	while $inner_switch
		write endsw\n
		pop inner_switch
	loop
	write '}\n'
	write \n'init\n{\n'$initproc\n'}\n'
	foreach iter procs
		write get(procs $iter)\n
	loop
	defstream outcgi get(ARGV 1).cgi basic true;
	writeto outcgi '#! /usr/local/bin/sl -c\n\n'
	writeto outcgi 'main\n{\n\tload(tmr-cgi)\n\trealmain('get(ARGV 1).sc\ get(ARGV 1).cgi.log')\n}\n'
}

 
process-value1(src)
{
	if tag(VALUE)
		if tag(INEXACT)
			return('eqi(trim('$src') 'stringize(tag(VALUE))')')
		else
			return('eq('$src' 'stringize(tag(VALUE))')')
		endif
	elsif tag(MATCH)
		return(cond(tag(INEXACT) 'matchi(' 'match(')stringize(tag(MATCH))' '$src')')
	elsif tag(PREFIX)
		return('isprefix('$src' 'stringize(tag(PREFIX))')')
	elsif tag(SUFFIX)
		return('issuffix('$src' 'stringize(tag(SUFFIX))')')
	elsif tag(CONTAINS)
		return(cond(tag(INEXACT) 'indexi(' 'index(')$src' 'stringize(tag(CONTAINS))')')
	elsif and(tag(BEFORE) tag(AFTER))
		return('between('stringize(tag(AFTER))' '$src' 'stringize(tag(BEFORE))')')
	elsif tag(BEFORE)
		return('less('$src' 'stringize(tag(BEFORE))')')
	elsif tag(AFTER)
		return('greater('$src' 'stringize(tag(AFTER))')')
	elsif tag(INMAP)
		return('check('stringize(tag(INMAP))' '$src')')
	endif
}

process-value(src)
{
	def tmp = process-value1($src);
	if and(tag(NOT) $tmp)
		set tmp = 'not('$tmp')'
	endif
	if and(tag(THRESHOLD) isint(tag(THRESHOLD)))
		if $tmp
			set tmp = 'and(greater(int 'tag(THRESHOLD)' $:threshold) '$tmp')'
		else
			set tmp = 'greater(int 'tag(THRESHOLD)' $:threshold)'
		endif
	endif
	return($tmp)
}

process-tag-desc(master='$[]')
{
	def tmp;
	if(tag(ATTR))
		set tmp = process-value('tag('tag(ATTR)')')
		if not($tmp) set tmp = 'tag('tag(ATTR)')' endif
		if tag(NAME)
			set tmp = 'and(eq('$master' 'stringize(tag(NAME))') '$tmp')'
		endif
	else
		set tmp = process-value($master)
		if not($tmp) return(true) endif
	endif
	return($tmp)
}

process-set-value(master='$[]')
{
	def tmp last first;
	if tag(TAG)
		set tmp = $master
	elsif tag(ATTR)
		set tmp = 'tag('tag(ATTR)')'
	else
		set tmp = stringize(tag(VALUE))
	endif
	if tag(REPLACE)
		if tag(START)
			set first = stringize(tag(START))
			if tag(END)
				set last = stringize(tag(END))
				set last = 'add(sub('$last' '$first') 1)'
			elsif tag(LEN)
				set last = stringize(tag(LEN))
			else
				error 'either END or LEN must be present'
			endif
			set tmp = 'replace('$tmp' '$first' '$last' 'stringize(tag(REPLACE))')'
		else
			set tmp = 'substit('$tmp' 'stringize(tag(SRC))' 'stringize(tag(REPLACE))cond(tag(FIRST) ' first')')'
		endif
	elsif tag(START)
		set first = stringize(tag(START))
		if tag(END)
			set last = stringize(tag(END))
			set last = 'add(sub('$last' '$first') 1)'
		elsif tag(LEN)
			set last = stringize(tag(LEN))
		else
			set last = ''
		endif
		set tmp = 'substr('$tmp' '$first' '$last')'
	endif
	if tag(TRIM)
		set tmp = 'trim('$tmp')'
	endif
	if tag(SPAN)
		set tmp = 'span('$tmp' 'stringize(tag(SPAN))')'
	endif
	if tag(MAP)
	 	set tmp = 'get('stringize(tag(MAP))' '$tmp')'
	endif
	if tag(TRANSLATE)
		set tmp = 'translate('stringize(tag(TRANSLATE))' '$tmp')'
	endif
	return($tmp)
}

stringize(val) { 
	if index($val '$')
		return('expand('\'translate(reset(stringize) $val)\'')')
	else
		return(\'translate(reset(stringize) $val)\')
	endif
}
