#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

realmain(file logging='')
{
	global :restart :next :current :state :filename :capture :supress :translator __logging;
	read
	write 'Content-Type: text/html'
	write ''
	load($file)
	init()
	def tmp tmp1 all = $[*];
	while $all
		set all = split($all '\t' '\n' tmp tmp1)
		global query.$tmp = $tmp1
	loop;
	set :filename = getenv(PATH_TRANSLATED)
	defstream input $:filename html;
	if $logging
		defstream logfile $logging basic true
		set __logging = true
	endif
	ioctl(input keepspaces)
	instream input
	if isproc(user-atbof) user-atbof() endif
	while;
		set :current = getpos(input)
		read
		set :next = getpos(input)
		if iseof() break endif
		if not($[])
			if $:capture
				set $:capture = var($:capture)$[value]
			elsif not($:supress)
				write translate($:translator $[value])
			endif
		else
			if do-handler() break endif
		endif
	loop;
	if and(iseof() isproc(user-ateof)) user-ateof() endif
}

message(text)
{
	if $__logging
		writeto logfile $text\n
	else
		echo $text
	endif
}

do-handler()
{
	def tmp newstate oldstate;
	while;
		if $newstate
			set oldstate = $:state
			set :state   = $newstate
		endif
		set tmp = handler($:restart)
		if $newstate
			set :state = $oldstate
		endif
		if eq($tmp nextfile) return(true) endif
		if isprefix($tmp restart)
			split($tmp ' ' '' '' :restart newstate)
		else
			break
		endif
	loop
}
