#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.ifhas ::module::readline
.module <readline>
.endif
.ifhas ::module::int64
.module <int64>
.endif
.module <files>
.ifhas ::module::crypt
.module <crypt>
.endif
.module <time>

get-line()
{
	def input;
	def prompt = $PS1;
	def final;
	while;
		set input = $(input)readline($prompt);
		if neq(\\ substr($input sub(length($input) 1))) 
			if $final
				if issuffix($input $final'>>')
					set input = substr($input 0 sub(length($input) add(length($final) 2)))
					break
				endif
			else
				if isprefix($input '<<')
					split(substr($input 2) ' ' '' final)
					set prompt = $PS2
					set input = ''
					continue
				else
					break
				endif
			endif
		endif
		set input = replace($input sub(length($input) 1) 1);
		set prompt = $PS2;
	loop;
	return($input)
}

main { catch(realmain()) }

realmain { echo "Tensile Shell v\.version()\n";
		trap SIGTERM really-quit
		trap SIGINT quit
		trap SIGQUIT quit
		array history;
		global PS1 = '# ' PS2 = '> ';
		def input;
		def a = "" 
			b = "a"
			c = "b"
			no = ''
			;
		def no1;
		undef b;
		onerror error-handler;
		while;
			set input = get-line()		
			if eq($input exit) break endif
			if eq(substr($input 0 1) '!')
				if eq($input '!')
					set no = sub(count(history) 1)
				elsif eq($input '!all')
					echo substr(apply(history gather-proc) 1)
					continue
				elsif isint(substr($input 1))
					set no = sub(substr($input 1) 1)
				else
					set no = ''
					foreach no1 history
						if isprefix($input get(history $no1))
							set no = $no1
							break
						endif
					loop
				endif
				if not(check(history $no))
					echo "No such history item";
					continue
				else
					set input = get(history $no)
					echo $input
				endif
			endif
			echo catch(eval($input));
			insert history count(history) $input
		loop
}


really-quit { exit }

quit { echo "$1 caught -- use \'\{ exit }\'  to terminate" }

gather-proc
{
	return("\nadd($2 1): get($1 $2)")
}

atexit { echo EXITED
	   }

error-handler
{
	echo "Echo: error occurred: $1 ($2:$3)"
	throw(<ERROR>)
}
