#
# 	Copyright (C) 2001, 2002 Artem V. Andreev (artem@AA5779.spb.edu)
#
#    This program is free software; you can redistribute it and/or modify
#    it under the terms of the GNU General Public License as published by
#    the Free Software Foundation; either version 2 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program; if not, write to the Free Software
#    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
#

.include <getopt>

main
{
	global format = '$(key): $value\n' prologue epilogue ifempty iferror
			keytran valtran gentran
			start limit = sysvar(sys:maxint) tname outfile
			mime = text/plain;
	onerror error-handler
	def iter handler counter = 0;
	getopt(list(prologue = @
				epilogue = @
				ifempty  = @
				iferror  = @
				format	 = @
				private  = @
				start    = :
				limit    = :
				mime	 = :
				m		 = =mime
				gentran  = :
				keytran  = :
				valtran  = :
				path	 = :
				table 	 = :
				t		 = =table
				output   = :
				o		 = =output
	) process-options)
	defautoseq keytran $keytran
	defautoseq valtran $valtran
	defautoseq gentran $gentran
	if not($tname)
		error "Missing table name"
	endif
	if getenv(GATEWAY_INTERFACE)
		read
		if tag(table)
			set tname = $[table]
		endif
		if tag(start)
			set start = $[start]
		endif
		if tag(limit)
			set limit = $[limit]
		endif
		write "Content-Type: $mime"
		write ""
		ioctl outstream() raw
	else
		defstream outs file://$outfile basic true;
		outstream outs
	endif
	table tbl +$tname
	def record = list(key value counter 
								start = $start 
								table = $tname
								limit = $limit							
					 );
	write translatez(gentran expand($prologue $record))
	set iter = sto.enum(tbl handler $start)
	if not(check(tbl $iter))
		write translatez(reset(gentran) expand($ifempty $record))
	else
		if eq($limit prefix)
			while(isprefix($iter $start));
				put $record key translatez(keytran $iter)
				put $record value translatez(valtran get(tbl $iter))
				put $record counter $counter
				incr counter 1
				write translatez(reset(gentran) expand($format $record))
				set iter = sto.enum(tbl handler)
			loop($handler);
		else			
			while(less(int $counter $limit));
				put $record key translatez(keytran $iter)
				put $record value translatez(valtran get(tbl $iter))
				put $record counter $counter
				incr counter 1
				write translatez(reset(gentran) expand($format $record))
				set iter = sto.enum(tbl handler)	
			loop($handler);
		endif
		if eq(int $counter 0) write expand($ifempty $record) endif
	endif
	put $record key translatez(keytran $iter)
	if $handler sto.break(tbl handler) endif
	write translatez(reset(gentran) expand($epilogue $record))
}

process-options(kind name arg extra)
{
	if eq($kind name)
		if not($tname)
			set tname = $name
		elsif $outfile
			error "Too many filenames"
		else
			set outfile = $name
		endif
	elsif eq($kind option)
		switch $name
			when eq($^ path)
				setenv SL_RO_TABLE_PATH "$(arg)cond(getenv(SL_RO_TABLE_PATH) \:getenv(SL_RO_TABLE_PATH))"
				breaksw
			when eq($^ private)
				au.new private
				au.build private $arg
				breaksw
			when eq($^ table)
				set tname = $arg
				breaksw
			when eq($^ output)
				set outfile = cond(neq($arg -) $arg)
				breaksw
			when true
				set $name = $arg
		endsw
	else
		error "Unknown option $name"
	endif
}

error-handler(desc fname line)
{
	echo "$fname\:$line\: $desc"
	exit
}
